import App
import MissionLib
import Tactical.LensFlares
import loadspacehelper
import SelfDefenseAI
import AttackAI

def Initialize(pSet):

	# Add a sun, far far away
	pSun = App.Sun_Create(5000.0, 5000.0, 500, "data/Textures/SunYellow.tga", "data/Textures/Effects/SunFlaresYellow.tga")
	pSet.AddObjectToSet(pSun, "Sun")
        
	# Place the object at the specified location.
	pSun.PlaceObjectByName( "Sun" )
	pSun.UpdateNodeOnly()

	# Builds a Yellow lens flare, attached to the sun
	Tactical.LensFlares.YellowLensFlare(pSet, pSun)

        # Model and placement for SFRD_TerranEmpireMod
        pPlanet = App.Planet_Create(310, "data/models/environment/SFRD_TerranEmpireMod/SFRD_Terra.NIF")
        pSet.AddObjectToSet(pPlanet, "SFRD_TerranEmpireMod")

        #Place the object at the specified location.
        pPlanet.PlaceObjectByName("SFRD_Terran Empire")
        pPlanet.UpdateNodeOnly()
        pPlanet.SetAtmosphereRadius(10)

	pMoon1 = App.Planet_Create(32.0,  "data/models/environment/SFRD_TerranEmpireMod/SFRD_TerranMoon.NIF")
	pSet.AddObjectToSet(pMoon1, "Moon")

	pMoon1.PlaceObjectByName("Moon Location")
	pMoon1.UpdateNodeOnly()

####################################################




####################################################



	if (App.g_kUtopiaModule.IsHost ()) or not (App.g_kUtopiaModule.IsMultiplayer()):

         	# Create ship

		pTholD	= loadspacehelper.CreateShip("TEFedStarbaseV2", pSet, "Space Dock", "Dock Location")

		pTholD.SetInvincible(0)
		pTholD.SetHurtable(1)
		pTholD.SetTargetable(1)
		pTholD.SetCollisionsOn(1)


		pThol1       = loadspacehelper.CreateShip("ISSPhiladelphia", pSet, "ISS Philadelphia", "Thol1 Location")

		pThol2       = loadspacehelper.CreateShip("TEPrometheus", pSet, "ISS Prometheus", "Thol2 Location")

		pThol3       = loadspacehelper.CreateShip("TE_JofA", pSet, "TE_JofA", "Thol3 Location")

		pThol4       = loadspacehelper.CreateShip("TEWarShipIntrepid", pSet, "TE WarShip", "Thol4 Location")

		pDef       = loadspacehelper.CreateShip("ISSEnterpriseA", pSet, "ISSEnterpriseA", "Def Location")
		pDef.SetCollisionsOn(0)

	if (App.g_kUtopiaModule.IsMultiplayer()):
		pMission = MissionLib.GetMission ()
		SetupEventHandlers(pMission)

	else:

                pGame = App.Game_GetCurrentGame() 
                pEpisode = pGame.GetCurrentEpisode() 
                pMission = pEpisode.GetCurrentMission()
                pNeutrals = pMission.GetNeutralGroup()
                if not pNeutrals.GetNameTuple():
                        pNeutrals.AddName("This ship probably wont exist 1")
                pEnemies = MissionLib.GetEnemyGroup()

                pFriendlies = MissionLib.GetFriendlyGroup()
                pFriendlies.AddName("ISSEnterpriseA")
                pFriendlies.AddName("Space Dock")
                pFriendlies.AddName("ISS Philadelphia")
                pFriendlies.AddName("ISS Prometheus")
                pFriendlies.AddName("TE_JofA")
                pFriendlies.AddName("TE WarShip")





###############################################################################
#       SetupEventHandlers()
#
#       Set up event handlers used by the Starbase 12 set.
#
#       Args:   pSet    - The Starbase 12 set.
#
#       Return: none
###############################################################################
def SetupEventHandlers(pMission):
	import Multiplayer.MissionShared
	App.g_kEventManager.AddBroadcastPythonFuncHandler(App.ET_OBJECT_CREATED_NOTIFY, pMission, __name__ + ".ObjectCreatedHandler")

	return 0


def ObjectCreatedHandler (TGObject, pEvent):
	import Multiplayer.SpeciesToShip

	# We only care about ships.
	pShip = App.ShipClass_Cast (pEvent.GetDestination ())
	if (pShip):
		# We only care about ships.
		if (pShip.IsPlayerShip ()):
			ResetEnemyFriendlyGroups ()
		elif (pShip.GetNetType () == Multiplayer.SpeciesToShip.FEDSTARBASE):
			pass
	return 0

def ResetEnemyFriendlyGroups ():
	# Go through player list, trying to find all the ships

	pNetwork = App.g_kUtopiaModule.GetNetwork ()
	pGame = App.MultiplayerGame_Cast (App.Game_GetCurrentGame ())

	if (pNetwork and pGame):
		pMission = MissionLib.GetMission ()
		pEnemyGroup = MissionLib.GetEnemyGroup ()
		pFriendyGroup = MissionLib.GetFriendlyGroup()
		pNeutralGroup = pMission.GetNeutralGroup ()

	pSet = App.g_kSetManager.GetSet("SFRD_TerranEmpireMod1")
	pTholD = App.ShipClass_GetObject(pSet, "Space Dock")
	pThol1 = App.ShipClass_GetObject(pSet, "ISS Philadelphia")
	pThol2 = App.ShipClass_GetObject(pSet, "ISS Prometheus")
	pThol3 = App.ShipClass_GetObject(pSet, "TE_JofA")
	pThol4 = App.ShipClass_GetObject(pSet, "TE WarShip")
	pDef = App.ShipClass_GetObject(pSet, "ISSEnterpriseA")


	if pTholD != None:
		pFriendyGroup.AddName("Space Dock")
		pTholD.SetAI(AttackAI.CreateAI(pTholD))

	if pThol1 != None:
		pFriendyGroup.AddName("A Ship 1")
		pThol1.SetAI(AttackAI.CreateAI(pThol1))


	if pThol2 != None:
		pFriendyGroup.AddName("B Ship 2")
		pThol2.SetAI(AttackAI.CreateAI(pThol2))


	if pThol3 != None:
		pFriendyGroup.AddName("R Ship 3")
		pThol3.SetAI(AttackAI.CreateAI(pThol3))


	if pThol4 != None:
		pFriendyGroup.AddName("AA Ship 4")
		pThol4.SetAI(AttackAI.CreateAI(pThol4))

	if pDef != None:
		pFriendlyGroup.AddName("ISSEnterpriseA")
		pDef.SetAI(AttackAI.CreateAI(pDef))


